Bug 1001728 - Review Request: rubygem-rkerberos - A Ruby interface for the the Kerberos library
Review Request: rubygem-rkerberos - A Ruby interface for the the Kerberos lib...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Simon A. Erat
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-08-27 11:25 EDT by Miroslav Suchý
Modified: 2015-06-23 08:14 EDT (History)
4 users (show)

See Also:
Fixed In Version: rubygem-rkerberos-0.1.3-2.fc20
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-10-29 21:55:30 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
erat.simon: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Miroslav Suchý 2013-08-27 11:25:40 EDT
Spec URL: http://miroslav.suchy.cz/fedora/rubygem-rkerberos/rubygem-rkerberos.spec
SRPM URL: http://miroslav.suchy.cz/fedora/rubygem-rkerberos/rubygem-rkerberos-0.1.2-3.fc19.src.rpm
Description: 
The rkerberos library is an interface for the Kerberos 5 network
authentication protocol. It wraps the Kerberos C API.

Fedora Account System Username: msuchy
Koji scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=5860611
Comment 1 Simon A. Erat 2013-09-05 22:30:33 EDT
Hello Miroslav

This is only a 'pre-review' and needs to be approved.
--
Informal Review
----------------
* Valid License named in specfile:
  Artistic 2.0
* Missing License:
  Either as file or link in readme/manual of the package
* Package fails to buld as noarch
  Is an 'interface' really required to be the same arch as the host-application - ruby?
* ruby is named in specfile as requirement

##----!!
Processing files: rubygem-rkerberos-0.1.2-3.fc19.noarch
+ popd
+ exit 0
Provides: rkerberos.so rubygem(rkerberos) = 0.1.2 rubygem-rkerberos = 0.1.2-3.fc19
Requires(rpmlib): rpmlib(CompressedFileNames) <= 3.0.4-1 rpmlib(FileDigests) <= 4.6.0-1 rpmlib(PayloadFilesHavePrefix) <= 4.0-1
Requires: libc.so.6 libc.so.6(GLIBC_2.0) libc.so.6(GLIBC_2.1.3) libc.so.6(GLIBC_2.4) libcom_err.so.2 libcrypt.so.1 libdl.so.2 libkadm5clnt_mit.so.8 libkadm5clnt_mit.so.8(kadm5clnt_mit_8_MIT) libkrb5.so.3 libkrb5.so.3(krb5_3_MIT) libm.so.6 libpthread.so.0 librt.so.1 libruby.so.2.0 rtld(GNU_HASH)
error: Arch dependent binaries in noarch package
RPM build errors:
    Arch dependent binaries in noarch package
Child return code was: 1
EXCEPTION: Command failed. See logs for output.
 # ['bash', '--login', '-c', 'rpmbuild -bb --target noarch --nodeps builddir/build/SPECS/rubygem-rkerberos.spec']
Traceback (most recent call last):
  File "/usr/lib/python2.7/site-packages/mockbuild/trace_decorator.py", line 70, in trace
    result = func(*args, **kw)
  File "/usr/lib/python2.7/site-packages/mockbuild/util.py", line 361, in do
    raise mockbuild.exception.Error, ("Command failed. See logs for output.\n # %s" % (command,), child.returncode)
Error: Command failed. See logs for output.
 # ['bash', '--login', '-c', 'rpmbuild -bb --target noarch --nodeps builddir/build/SPECS/rubygem-rkerberos.spec']
LEAVE do --> EXCEPTION RAISED
##----!!



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- gems should require rubygems package
  Note: Requires: rubygems missing in rubygem-rkerberos-doc
  See: http://fedoraproject.org/wiki/Packaging:Ruby#RubyGems
- Pure Ruby package must be built as noarch
- Package contains Requires: ruby(release).


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[-]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
  ---Its in: /usr/lib64/gems/ruby/rkerberos-0.1.2/lib
     What does that mean?   
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[-]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[ ]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 20 files have unknown license. Detailed output of
     licensecheck in /home/simon/1001728-rubygem-rkerberos/licensecheck.txt
     
[!]: License file installed when any subpackage combination is installed.
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/share/gems/gems/rkerberos-0.1.2
[x]: Package must own all directories that it creates.
     Note: Directories without known owners:
     /usr/share/gems/gems/rkerberos-0.1.2, /usr/share/gems,
     /usr/share/gems/doc, /usr/share/gems/gems
[x]: %build honors applicable compiler flags or justifies otherwise.
[ ]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[ ]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf %{buildroot} present but not required
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[!]: Development files must be in a -devel package
   --they are in a -debug package
[ ]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[ ]: Useful -debuginfo package or justification otherwise.
   -- cant tell, idk what ruby coders need to debug usefull
[ ]: Package is not known to require an ExcludeArch tag.
     Note: Test run failed
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Test run failed
[x]: Packages must not store files under /srv, /opt or /usr/local
     Note: Test run failed
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.

Ruby:
[x]: Platform dependent files must all go under %{gem_extdir_mri}, platform
     independent under %{gem_dir}.
[x]: Gem package must not define a non-gem subpackage
[x]: Macro %{gem_extdir} is deprecated.
[x]: Gem package is named rubygem-%{gem_name}
[x]: Package contains BuildRequires: rubygems-devel.
[x]: Gem package must define %{gem_name} macro.
[x]: Package does not contain Requires: ruby(abi).

===== SHOULD items =====

Generic:
[!]: Dist tag is present (not strictly required in GL).
[!]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[!]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in rubygem-
     rkerberos-doc
[x]: Package functions as described.
[x]: Latest version is packaged.
[!]: Package does not include license text files separate from upstream.
  -- does not contain any license information but the spec info.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[!]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Ruby:
[!]: Gem should use %gem_install macro.
[-]: Specfile should use macros from rubygem-devel package.
     Note: The specfile doesn't use these macros: %exclude %{gem_cache},
     %{gem_libdir}, %{gem_spec}
[x]: Gem package should exclude cached Gem.
[x]: Test suite of the library should be run.

===== EXTRA items =====

Generic:
[-]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
     Note: Test run failed
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: rubygem-rkerberos-0.1.2-3.fc21.x86_64.rpm
          rubygem-rkerberos-doc-0.1.2-3.fc21.noarch.rpm
          rubygem-rkerberos-0.1.2-3.fc21.src.rpm
rubygem-rkerberos.x86_64: W: no-soname /usr/lib64/gems/ruby/rkerberos-0.1.2/lib/rkerberos.so
3 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint rubygem-rkerberos rubygem-rkerberos-doc
rubygem-rkerberos.x86_64: W: no-soname /usr/lib64/gems/ruby/rkerberos-0.1.2/lib/rkerberos.so
rubygem-rkerberos.x86_64: W: unused-direct-shlib-dependency /usr/lib64/gems/ruby/rkerberos-0.1.2/lib/rkerberos.so /lib64/libpthread.so.0
rubygem-rkerberos.x86_64: W: unused-direct-shlib-dependency /usr/lib64/gems/ruby/rkerberos-0.1.2/lib/rkerberos.so /lib64/librt.so.1
rubygem-rkerberos.x86_64: W: unused-direct-shlib-dependency /usr/lib64/gems/ruby/rkerberos-0.1.2/lib/rkerberos.so /lib64/libdl.so.2
rubygem-rkerberos.x86_64: W: unused-direct-shlib-dependency /usr/lib64/gems/ruby/rkerberos-0.1.2/lib/rkerberos.so /lib64/libcrypt.so.1
rubygem-rkerberos.x86_64: W: unused-direct-shlib-dependency /usr/lib64/gems/ruby/rkerberos-0.1.2/lib/rkerberos.so /lib64/libm.so.6
2 packages and 0 specfiles checked; 0 errors, 6 warnings.
# echo 'rpmlint-done:'



Requires
--------
rubygem-rkerberos (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libcom_err.so.2()(64bit)
    libcrypt.so.1()(64bit)
    libdl.so.2()(64bit)
    libkadm5clnt_mit.so.8()(64bit)
    libkadm5clnt_mit.so.8(kadm5clnt_mit_8_MIT)(64bit)
    libkrb5.so.3()(64bit)
    libkrb5.so.3(krb5_3_MIT)(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    librt.so.1()(64bit)
    libruby.so.2.0()(64bit)
    rtld(GNU_HASH)
    ruby
    rubygems

rubygem-rkerberos-doc (rpmlib, GLIBC filtered):
    rubygem-rkerberos



Provides
--------
rubygem-rkerberos:
    rubygem(rkerberos)
    rubygem-rkerberos
    rubygem-rkerberos(x86-64)

rubygem-rkerberos-doc:
    rubygem-rkerberos-doc



Unversioned so-files
--------------------
rubygem-rkerberos: /usr/lib64/gems/ruby/rkerberos-0.1.2/lib/rkerberos.so

Source checksums
----------------
http://rubygems.org/downloads/rkerberos-0.1.2.gem :
  CHECKSUM(SHA256) this package     : 1ff4d8a4925ce6505812b26e247a2c272bc94299cd43a6860415590b5921c8d5
  CHECKSUM(SHA256) upstream package : 1ff4d8a4925ce6505812b26e247a2c272bc94299cd43a6860415590b5921c8d5


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/bin/fedora-review -m fedora-rawhide-x86_64 -b 1001728
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Ruby, Shell-api, C/C++
Disabled plugins: Java, Python, SugarActivity, Perl, R, PHP
Disabled flags: EPEL5, EXARCH, DISTTAG
Comment 2 Björn "besser82" Esser 2013-09-06 03:40:21 EDT
(In reply to Simon A. Erat from comment #1)
> Hello Miroslav
> 
> Informal Review
> ----------------
> * Valid License named in specfile:
>   Artistic 2.0
> * Missing License:
>   Either as file or link in readme/manual of the package

There MUST be a copy of LICENSE within, in this case.  Link within README would not be sufficient according to Artistic 2.0 "Permissions for Redistribution of the Standard Version" No. 2 "... provided that you duplicate all of the original copyright notices and associated disclaimers ..."

You should add this as another SOURCE to spec-file:

  Source1: http://www.perlfoundation.org/attachment/legal/artistic-2_0.txt

copy it into src-tree `cp -a %{SOURCE1} COPYING` during %prep and include it for %doc.


> * Package fails to buld as noarch
>   Is an 'interface' really required to be the same arch as the
> host-application

In this case yes, because it builds and provides a C-compiled interface.


> ##----!!
> Processing files: rubygem-rkerberos-0.1.2-3.fc19.noarch
> + popd
> + exit 0
> Provides: rkerberos.so rubygem(rkerberos) = 0.1.2 rubygem-rkerberos =
> 0.1.2-3.fc19
> Requires(rpmlib): rpmlib(CompressedFileNames) <= 3.0.4-1 rpmlib(FileDigests)
> <= 4.6.0-1 rpmlib(PayloadFilesHavePrefix) <= 4.0-1
> Requires: libc.so.6 libc.so.6(GLIBC_2.0) libc.so.6(GLIBC_2.1.3)
> libc.so.6(GLIBC_2.4) libcom_err.so.2 libcrypt.so.1 libdl.so.2
> libkadm5clnt_mit.so.8 libkadm5clnt_mit.so.8(kadm5clnt_mit_8_MIT)
> libkrb5.so.3 libkrb5.so.3(krb5_3_MIT) libm.so.6 libpthread.so.0 librt.so.1
> libruby.so.2.0 rtld(GNU_HASH)
> error: Arch dependent binaries in noarch package

There you get it.  C-compiled stuff :)


> Issues:
> =======
> - gems should require rubygems package
>   Note: Requires: rubygems missing in rubygem-rkerberos-doc
>   See: http://fedoraproject.org/wiki/Packaging:Ruby#RubyGems

False positve from f-r.  It is present, but with SCL-macro prefixed:
  Requires: %{?scl_prefix}rubygems


> - Pure Ruby package must be built as noarch
> - Package contains Requires: ruby(release).

False positive here, too.  C-compiled interface.


> [-]: Development (unversioned) .so files in -devel subpackage, if present.
>      Note: Unversioned so-files in private %_libdir subdirectory (see
>      attachment). Verify they are not in ld path.
>   ---Its in: /usr/lib64/gems/ruby/rkerberos-0.1.2/lib
>      What does that mean?   

This can actually be marked as "PASS", because:

  * It is supposed for C-compiled interfaces to have no SO-Version.

  * Applies to *.so-files which are directly placed inside %{_libdir}, mostly.


> [ ]: License field in the package spec file matches the actual license.
>      Note: Checking patched sources after %prep for licenses. Licenses found:
>      "Unknown or generated". 20 files have unknown license. Detailed output
> of
>      licensecheck in /home/simon/1001728-rubygem-rkerberos/licensecheck.txt

This can be marked "PASS".  Having no explicit license commented inside the file usualy means: Same license as in distributed LICENSE/COPYING.


> [!]: License file installed when any subpackage combination is installed.

Yes, obviously there is no license file....


> [x]: Package must own all directories that it creates.
>      Note: Directories without known owners:
>      /usr/share/gems/gems/rkerberos-0.1.2, /usr/share/gems,
>      /usr/share/gems/doc, /usr/share/gems/gems

This would need some more manual inspection...


> [x]: %build honors applicable compiler flags or justifies otherwise.

LDFLAGS are not applied when linking obj to so.  I'd usually recommend to have "%configure ||:" on top of %build, so all FLAGS get exported properly.


> [ ]: Package contains no bundled libraries without FPC exception.

Can be marked "PASS".  There seem no bundled files / libs or subsets of them.


> [ ]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
>      beginning of %install.
>      Note: rm -rf %{buildroot} present but not required

False positive.  This is PASS.


> [!]: Development files must be in a -devel package
>    --they are in a -debug package

What???  The debug-pkg looks sane to me.  It is the regular fashion that -debug contains a copy of all sources and the DWARF-part of the linked-binaries.


> [ ]: Package uses nothing in %doc for runtime.

PASS


> [ ]: Useful -debuginfo package or justification otherwise.
>    -- cant tell, idk what ruby coders need to debug usefull

Having a look inside it should tell ;)  There must be the sources and the DWARF-parts of every build binary inside.  To me it looks good.  ;)


> [ ]: Package is not known to require an ExcludeArch tag.
>      Note: Test run failed
> [x]: Large documentation must go in a -doc subpackage. Large could be size
>      (~1MB) or number of files.
>      Note: Test run failed
> [x]: Packages must not store files under /srv, /opt or /usr/local
>      Note: Test run failed

What did you do to your system?  None of these fail, if I run f-r of this.  I'd recommend you to use some stock F19+ vm to run reviews on.

The ExcludeArch thing is PASS btw.


> [x]: Package complies to the Packaging Guidelines

This cannot be.  There acutally _are_ issues present.


> [!]: Dist tag is present (not strictly required in GL).

Is present, but the wrong way:  %{dist}  --->  %{?dist}


> [!]: If the source package does not include license text(s) as a separate
>      file from upstream, the packager SHOULD query upstream to include it.

In fact for the Artistic 2.0 it IS required to ship it with the binaries.


> [!]: Fully versioned dependency in subpackages if applicable.
>      Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in rubygem-
>      rkerberos-doc

There is for some unknown reason "Requires: %{name} = %{version}-%{release}" in the -doc pkg.  -doc pkgs should not have requires to main pkg, because I usually want to read the docs BEFORE installing any binaries or related.  ;)


> [!]: Package does not include license text files separate from upstream.
>   -- does not contain any license information but the spec info.

See my comment above.


> [!]: Package should compile and build into binary rpms on all supported
>      architectures.

Why do mark this as FAIL?  Scratch-build on Koji shows it successfuly builds on all primary arches.


> [ ]: %check is present and all tests pass.

It actually isn't.  You should uncomment the testsuite in spec and append " ||:" to the command, so we can see at least which test are run and which fail.  This is helpful to get a conclusion about what is wrong, if there's any.


> Ruby:
> [!]: Gem should use %gem_install macro.

False positve.  Present and used.


> [-]: Specfile should use macros from rubygem-devel package.
>      Note: The specfile doesn't use these macros: %exclude %{gem_cache},
>      %{gem_libdir}, %{gem_spec}

False positve.  They are prensent and used.


> [x]: Test suite of the library should be run.

FAIL!  It actually isn't.  You should uncomment the testsuite in spec and append " ||:" to the command, so we can see at least which test are run and which fail.  This is helpful to get a conclusion about what is wrong, if there's any.


> [-]: Large data in /usr/share should live in a noarch subpackage if package
>      is arched.
>      Note: Test run failed

See my comments about modified environments above.

And I don't think it's common practice to have CHANGES, MANIFEST, README inside %{gem_instdir}.  Please remove them during install and include them as "regular" %doc inside -doc pkg.

Same goes for:

  %{gem_instdir}/rkerberos.gemspec
  %{gem_instdir}/test
  %{gem_instdir}/Rakefile

inside -doc pkg.  What is a useful purpose for them?

Don't forget to include COPYING into both pkgs (main and -doc).

#####

Miroslav, please fixup the mentioned things:

  * inclusion of COPYING
  * proper export of C/LDFLAGS
  * %doc fixup

And provide us with updated SPEC/SRPM, please.
Comment 3 Miroslav Suchý 2013-09-08 08:50:46 EDT
ad dist tag - fixed

ad %doc fixup of:
> And I don't think it's common practice to have CHANGES, MANIFEST, README inside %{gem_instdir}
Sadly this is "habit" of rubygem. See my proposal:
https://lists.fedoraproject.org/pipermail/ruby-sig/2013-August/001418.html
But yes, I will edit it to follow my own proposal.

>  %{gem_instdir}/rkerberos.gemspec
>  %{gem_instdir}/test
>  %{gem_instdir}/Rakefile
This is not needed for runtime. Therefore it should not be in main package. It is (or can be) usefull for developers. Well, if we will be dogmatic, this may go to -devel package, but it is waste to create another subpackage because of three files. So those files are put in -doc subpackage. This is common habit for rubygems-* packages in Fedora.

ad Including License. I asked upstream to include license. And here it comes:
https://github.com/domcleal/rkerberos/issues/2#issuecomment-24011309

ad LDFLAGS - what do you mean? There is no configure script so running %configure IMHO have no effect. There is used %gem_install macro, which expands to:
%gem_install(d:n:) \
mkdir -p %{-d*}%{!?-d:.%{gem_dir}} \
\
CONFIGURE_ARGS="--with-cflags='%{optflags}' $CONFIGURE_ARGS" \\\
gem install \\\
        -V \\\
        --local \\\
        --install-dir %{-d*}%{!?-d:.%{gem_dir}} \\\
        --bindir .%{_bindir} \\\
        --force \\\
        --document=ri,rdoc \\\
        --backtrace \\\
        %{-n*}%{!?-n:%{gem_name}-%{version}.gem} \
%{nil}
And this is provided by rubygems-devel. If there is some incorrection, it should be fixed by rubygems-devel. IMO.
Comment 5 Simon A. Erat 2013-10-14 06:20:59 EDT
Informal Review:
================
Add: "%doc %{_pkgdocdir}/LICENSE
    %doc %{gem_instdir}/LICENSE" to %files doc 

Once that's added, it looks fine to me.
Björn?


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- gems should require rubygems package
  Note: Requires: rubygems missing in rubygem-rkerberos-doc
  See: http://fedoraproject.org/wiki/Packaging:Ruby#RubyGems
- Pure Ruby package must be built as noarch
- Package contains Requires: ruby(release).


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 20 files have unknown license. Detailed output of
     licensecheck in /home/simon/1001728-rubygem-rkerberos/licensecheck.txt
[!]: License file installed when any subpackage combination is installed.
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/share/gems/gems/rkerberos-0.1.3,
     /usr/share/doc/rubygem-rkerberos
[x]: Package must own all directories that it creates.
     Note: Directories without known owners:
     /usr/share/gems/gems/rkerberos-0.1.3, /usr/share/gems/gems,
     /usr/share/gems/doc, /usr/share/doc/rubygem-rkerberos, /usr/share/gems
[x]: %build honors applicable compiler flags or justifies otherwise.
[?]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf %{buildroot} present but not required
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[?]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
     Note: Test run failed
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Test run failed
[x]: Packages must not store files under /srv, /opt or /usr/local
     Note: Test run failed
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.

Ruby:
[x]: Platform dependent files must all go under %{gem_extdir_mri}, platform
     independent under %{gem_dir}.
[x]: Gem package must not define a non-gem subpackage
[x]: Macro %{gem_extdir} is deprecated.
[x]: Gem package is named rubygem-%{gem_name}
[x]: Package contains BuildRequires: rubygems-devel.
[x]: Gem package must define %{gem_name} macro.
[x]: Package does not contain Requires: ruby(abi).

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in rubygem-
     rkerberos-doc
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Ruby:
[x]: Gem should use %gem_install macro.
[x]: Specfile should use macros from rubygem-devel package.
     Note: The specfile doesn't use these macros: %{gem_spec}, %{gem_libdir},
     %exclude %{gem_cache}
[x]: Gem package should exclude cached Gem.
[x]: Test suite of the library should be run.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
     Note: Test run failed
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: rubygem-rkerberos-0.1.3-1.fc21.i686.rpm
          rubygem-rkerberos-doc-0.1.3-1.fc21.noarch.rpm
          rubygem-rkerberos-0.1.3-1.fc21.src.rpm
rubygem-rkerberos.i686: W: no-soname /usr/lib/gems/ruby/rkerberos-0.1.3/lib/rkerberos.so
3 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint rubygem-rkerberos rubygem-rkerberos-doc
rubygem-rkerberos.i686: W: no-soname /usr/lib/gems/ruby/rkerberos-0.1.3/lib/rkerberos.so
rubygem-rkerberos.i686: W: unused-direct-shlib-dependency /usr/lib/gems/ruby/rkerberos-0.1.3/lib/rkerberos.so /lib/libpthread.so.0
rubygem-rkerberos.i686: W: unused-direct-shlib-dependency /usr/lib/gems/ruby/rkerberos-0.1.3/lib/rkerberos.so /lib/librt.so.1
rubygem-rkerberos.i686: W: unused-direct-shlib-dependency /usr/lib/gems/ruby/rkerberos-0.1.3/lib/rkerberos.so /lib/libdl.so.2
rubygem-rkerberos.i686: W: unused-direct-shlib-dependency /usr/lib/gems/ruby/rkerberos-0.1.3/lib/rkerberos.so /lib/libcrypt.so.1
rubygem-rkerberos.i686: W: unused-direct-shlib-dependency /usr/lib/gems/ruby/rkerberos-0.1.3/lib/rkerberos.so /lib/libm.so.6
2 packages and 0 specfiles checked; 0 errors, 6 warnings.
# echo 'rpmlint-done:'



Requires
--------
rubygem-rkerberos (rpmlib, GLIBC filtered):
    libc.so.6
    libcom_err.so.2
    libcrypt.so.1
    libdl.so.2
    libkadm5clnt_mit.so.8
    libkadm5clnt_mit.so.8(kadm5clnt_mit_8_MIT)
    libkrb5.so.3
    libkrb5.so.3(krb5_3_MIT)
    libm.so.6
    libpthread.so.0
    librt.so.1
    libruby.so.2.0
    rtld(GNU_HASH)
    ruby
    rubygems

rubygem-rkerberos-doc (rpmlib, GLIBC filtered):
    rubygem-rkerberos



Provides
--------
rubygem-rkerberos:
    rubygem(rkerberos)
    rubygem-rkerberos
    rubygem-rkerberos(x86-32)

rubygem-rkerberos-doc:
    rubygem-rkerberos-doc



Unversioned so-files
--------------------
rubygem-rkerberos: /usr/lib/gems/ruby/rkerberos-0.1.3/lib/rkerberos.so

Source checksums
----------------
http://rubygems.org/downloads/rkerberos-0.1.3.gem :
  CHECKSUM(SHA256) this package     : 60a05d5d5dc0bf462bac0346bf9a984a478d882e85ff2115b61aad0088de7a29
  CHECKSUM(SHA256) upstream package : 60a05d5d5dc0bf462bac0346bf9a984a478d882e85ff2115b61aad0088de7a29


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/bin/fedora-review -m fedora-rawhide-i386 -b 1001728
Buildroot used: fedora-rawhide-i386
Active plugins: Generic, Ruby, Shell-api, C/C++
Disabled plugins: Java, Python, SugarActivity, Perl, R, PHP
Disabled flags: EPEL5, EXARCH, DISTTAG
Comment 6 Miroslav Suchý 2013-10-14 07:57:16 EDT
>Add: "%doc %{_pkgdocdir}/LICENSE
>    %doc %{gem_instdir}/LICENSE" to %files doc 
>
>Once that's added, it looks fine to me.

-doc subpackage is dependant on base package, therefore does not need specific license file.
See https://fedoraproject.org/wiki/Packaging:LicensingGuidelines?rd=Packaging/LicensingGuidelines#Subpackage_Licensing

>- gems should require rubygems package
>  Note: Requires: rubygems missing in rubygem-rkerberos-doc
>  See: http://fedoraproject.org/wiki/Packaging:Ruby#RubyGems
>- Pure Ruby package must be built as noarch
>- Package contains Requires: ruby(release).

This is false negatives of fedora-review.
Comment 7 Simon A. Erat 2013-10-15 06:35:16 EDT
Right, good point - so i'd give it a go.
Björn needs to confirm that for you.
Comment 8 Björn "besser82" Esser 2013-10-20 02:41:44 EDT
(In reply to Miroslav Suchý from comment #6)
> >Add: "%doc %{_pkgdocdir}/LICENSE
> >    %doc %{gem_instdir}/LICENSE" to %files doc 
> >
> >Once that's added, it looks fine to me.
> 
> -doc subpackage is dependant on base package, therefore does not need
> specific license file.
> See
> https://fedoraproject.org/wiki/Packaging:LicensingGuidelines?rd=Packaging/
> LicensingGuidelines#Subpackage_Licensing

The doc sub-package should be independent from "binary"-packages, because one would usualy read the doc BEFORE installing the app / binary / lib.

In this case I'd _strongly_ suggest to add this to the -doc pkg:

  %doc %{_pkgdocdir}/README.md
  %doc %{gem_instdir}/README.md
  %doc %{_pkgdocdir}/LICENSE
  %doc %{gem_instdir}/LICENSE

This is explicitly allowed and couraged by the guildelines you quoted and I think you can do that during import.  I wouldn't force another pkg-update for this...

> >- gems should require rubygems package
> >  Note: Requires: rubygems missing in rubygem-rkerberos-doc
> >  See: http://fedoraproject.org/wiki/Packaging:Ruby#RubyGems
> >- Pure Ruby package must be built as noarch
> >- Package contains Requires: ruby(release).
> 
> This is false negatives of fedora-review.

Both are confirmed to be false positives.


(In reply to Simon A. Erat from comment #7)
> Right, good point - so i'd give it a go.
> Björn needs to confirm that for you.


Simon, msuchy is trustworthy enough to get this package approved.  I'm sure he will make the needed (small) changes during import, so you safely can grant review for this.
Comment 9 Simon A. Erat 2013-10-20 08:30:07 EDT
APPROVED
Comment 10 Miroslav Suchý 2013-10-21 05:09:44 EDT
Björn - I hesitate to do this change. Because this goes against the change how all other rubygems-packages are packaged.

I spoke with Vit Ondruch about it and the historic reason is because rubygem documentation is put in %{gem_instdir} and -doc subpackage would need to own that directory as well. So ruby-sig decided to just require that main directory.

I done some investigation how other languages do that and I agree with you that other langs do that as you said. So I will open this discussion on ruby-sig.
But in mean time I will package it using current ruby habits.
Comment 11 Miroslav Suchý 2013-10-21 08:00:20 EDT
New Package SCM Request
=======================
Package Name: rubygem-rkerberos
Short Description: A Ruby interface for the the Kerberos library
Owners: msuchy
Branches: f19 f20
InitialCC:
Comment 12 Gwyn Ciesla 2013-10-21 08:18:19 EDT
Git done (by process-git-requests).
Comment 13 Fedora Update System 2013-10-21 08:35:02 EDT
rubygem-rkerberos-0.1.3-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/rubygem-rkerberos-0.1.3-2.fc19
Comment 14 Fedora Update System 2013-10-21 09:07:12 EDT
rubygem-rkerberos-0.1.3-2.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/rubygem-rkerberos-0.1.3-2.fc20
Comment 15 Fedora Update System 2013-10-21 14:28:47 EDT
rubygem-rkerberos-0.1.3-2.fc20 has been pushed to the Fedora 20 testing repository.
Comment 16 Fedora Update System 2013-10-29 21:55:30 EDT
rubygem-rkerberos-0.1.3-2.fc19 has been pushed to the Fedora 19 stable repository.
Comment 17 Fedora Update System 2013-11-10 03:00:50 EST
rubygem-rkerberos-0.1.3-2.fc20 has been pushed to the Fedora 20 stable repository.
Comment 18 Dominic Cleal 2015-06-23 04:59:10 EDT
Package Change Request
======================
Package Name: rubygem-rkerberos
New Branches: epel7
Owners: domcleal
InitialCC: msuchy

To resolve bug #1234260
Comment 19 Gwyn Ciesla 2015-06-23 08:14:39 EDT
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.